#define WIN32_LEAN_AND_MEAN
#include "Chapt2.h"
#include "FindIgos.h"

WINBASEAPI
DWORD
WINAPI
GetTickCount(
    VOID
    );


int Resolution=GR_RESOLUTION_800x600;
bool AntiAliasing=false;
DWORD Frames=0;
DWORD TickCount=GetTickCount();

GrContext_t		Context;
FxI32			Num3Dfx;
static  FxI32  gr_wrange[2];

static void BufferClear (void)
{
    grDepthMask (FXTRUE);
    grColorMask (FXTRUE,FXFALSE);
    grBufferClear(0x00000000, 0, gr_wrange[1]);
}

bool Start(HWND hWnd);
void ShutDown();
bool Drawing(void);

LRESULT CALLBACK WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{WNDCLASS	wc;
 HWND		hWnd;
 MSG		Msg;

 wc.style         = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc   = WindowProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
 wc.hCursor       = LoadCursor(NULL, IDC_ARROW); //  
 wc.hbrBackground = NULL;                        //  
 wc.lpszMenuName  = NULL;                        //    
 wc.lpszClassName = "Chapter2";
 RegisterClass(&wc);
 hWnd = CreateWindow("Chapter2",
                     "Glide3 Demo",
                     WS_POPUP,
                     0, 0,
                     GetSystemMetrics(SM_CXSCREEN),
                     GetSystemMetrics(SM_CYSCREEN),
                     NULL,
                     NULL,
                     hInstance,
                     NULL);
 if (hWnd == NULL)
  return 1;
 ShowWindow(hWnd, nCmdShow);
 while (GetMessage(&Msg, NULL, 0, 0))
 {TranslateMessage(&Msg);
  DispatchMessage(&Msg);
 }
 return 0;
}



LRESULT CALLBACK WindowProc(HWND hWnd,
                            UINT uMsg,
                            WPARAM wParam,
                            LPARAM lParam)
{switch (uMsg)
 {case WM_CREATE:
   if (!Start(hWnd))
    return -1;
   Drawing();
   ShutDown();
   PostQuitMessage(0);
   ExitProcess(1000*Frames/(GetTickCount()-TickCount));
   return 0;
  case WM_SETCURSOR:
   SetCursor(FALSE);
   return TRUE;
 }
 return DefWindowProc(hWnd, uMsg, wParam, lParam);
}


bool Start(HWND hWnd)
{
 if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx))
  return false;
 grGlideInit();
 grSstSelect(0);
 Context = grSstWinOpen((FxU32)hWnd,             //  
                        Resolution,              // 
                        GR_REFRESH_75Hz,         //  
                        GR_COLORFORMAT_ABGR,     //  
                        GR_ORIGIN_LOWER_LEFT,	 //   (0,0)
                        2,                       //  
                        1);                      //    Z-
 if (Context == NULL)
  return false;
 return true;
}

void ShutDown()
{grSstWinClose(Context);
 grGlideShutdown();
}

void InitGlide() {
	//   -
	//grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, //   -
    //            GR_COMBINE_FACTOR_ONE,           // 
    //            GR_COMBINE_LOCAL_NONE,           //
    //            GR_COMBINE_OTHER_ITERATED,       //
    //            FXFALSE);                        //   -
	grEnable(GR_AA_ORDERED);                        //  -

	/*grAlphaBlendFunction(GR_BLEND_SRC_ALPHA,
                      GR_BLEND_ONE_MINUS_SRC_ALPHA,
                      GR_BLEND_ZERO,
                      GR_BLEND_ZERO);*/

	//FxI32 wLimits[2];
	//grGet(GR_WDEPTH_MIN_MAX,2,wLimits);
	//grDepthBufferMode( GR_DEPTHBUFFER_WBUFFER );
	//grDepthBufferFunction( GR_CMP_LESS ); // larger W values are fartheraway
	//grDepthMask( FXTRUE );
	//grBufferClear(0, 0, wLimits[1]);

	//  Z-
	//grDepthBufferMode(GR_DEPTHBUFFER_WBUFFER);      //  Z-
	//grDepthBufferFunction(GR_CMP_GREATER);
	//grDepthMask(FXTRUE);
 
	grColorCombine(GR_COMBINE_FUNCTION_LOCAL,
                GR_COMBINE_FACTOR_ONE,
                GR_COMBINE_LOCAL_ITERATED,
				GR_COMBINE_OTHER_ITERATED,
				FXFALSE);

	//grEnable(GR_AA_ORDERED);

	grGet (GR_WDEPTH_MIN_MAX, 8, gr_wrange);
	grCoordinateSpace(GR_WINDOW_COORDS);
	grViewport((FxU32)0,(FxU32)0,(FxU32)800,(FxU32)600);
	grDepthRange(0.0,1.0);
	grDepthBufferMode(GR_DEPTHBUFFER_WBUFFER);
	grDepthBufferFunction( GR_CMP_LEQUAL );
	grDepthMask( FXTRUE );
	grColorMask ( FXTRUE, FXFALSE);

	grVertexLayout(GR_PARAM_XY, 0, GR_PARAM_ENABLE);//   X, Y
	grVertexLayout(GR_PARAM_Z, 8, GR_PARAM_ENABLE); // W
	grVertexLayout(GR_PARAM_RGB, 12, GR_PARAM_ENABLE);//   RGB
	grVertexLayout(GR_PARAM_A, 24, GR_PARAM_ENABLE);// -nfsexit

	grBufferClear( 0, 0, 0 );

}

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------

HANDLE hKeyHook;
DWORD IdKeyHook;
FlatWall fw[2];


bool Drawing(void) {
	myVertex p1,p2,p3;
	p1.a=255.0;
	p1.r=255.0;
	p1.g=255.0;
	p1.b=255.0;
	p1.z=1.0F;
	p1.x=0.0;
	p1.y=0.0;
	

	p2.a=255.0;
	p2.r=255.0;
	p2.g=255.0;
	p2.b=255.0;
	p2.z=1.0F;
	p2.x=0.200;
	p2.y=0.200;
	

	p3.a=255.0;
	p3.r=255.0;
	p3.g=255.0;
	p3.b=255.0;
	p3.z=1.0F;
	p3.x=0.0;
	p3.y=0.500;
	

	InitGlide();

	fw[0].p1.x=10;
	fw[0].p1.y=-5;
	fw[0].p1.z=0;
	fw[0].p2.x=10;
	fw[0].p2.y=5;
	fw[0].p2.z=1;
	fw[0].r=255;
	fw[0].g=255;
	fw[0].b=255;
	fw[0].a=255;
	fw[1].p1.x=9;
	fw[1].p1.y=-5;
	fw[1].p1.z=0;
	fw[1].p2.x=4;
	fw[1].p2.y=-5;
	fw[1].p2.z=2.5;
	fw[1].r=0;
	fw[1].g=0;
	fw[1].b=255;
	fw[1].a=100;
	hKeyHook=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)KeyHook,NULL,0,&IdKeyHook);
	if (hKeyHook==NULL) return false;

	for (int t=0; t<100000; t++) {
		BufferClear();
		/*for (int f=0; f<nFace; f++) {
			for (int i=0; i<nStarsPerFace; i++) {
				Sky[f][i].x +=(float)1/(f+1);
				if(Sky[f][i].x >= ResolutionX-1) {
					Sky[f][i].x=0;
					Sky[f][i].y=(float)(rand()%(ResolutionY-1));
				}
			}
		}*/
		//grDrawVertexArrayContiguous(GR_POINTS, nStarsPerFace*nFace, &Sky[0][0], sizeof(myVertex));
		fw[0].Draw();
		fw[1].Draw();
		//grDrawTriangle(&p1,&p2,&p3);
		Frames++;
		grBufferSwap(0);
		//if () AntiAliasing=!AntiAliasing;
		if (GetAsyncKeyState(VK_ESCAPE)) return true;

	}

	return true;
}

