#define WIN32_LEAN_AND_MEAN

#include "Chapt1.h"
#include "Geometry.h"
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>	
#include <string.h>
#include <math.h>

#define GLIDE_DRAWING

const float pi=3.14159265358979;
const float e0=0.001;

const int TextureCount=3;
char PictureFileName[TextureCount][16]={"BW.bmp","floor.bmp","ceiling.bmp"};
GrTexInfo Textures[TextureCount];
FxU32 TexAddr[TextureCount];
bool TexBlur[TextureCount]={true,true,true};

const int WallCount=4;
Wall Walls[WallCount]={
	{-10,10,10,10,0xFFFFFFFF},
	{10,10,10,-10,0xFFFFFFFF},
	{10,-10,-10,-10,0xFFFFFFFF},
	{-10,-10,-10,10,0xFFFFFFFF}
};
float WallHeight=2.56;
Camera Personage={0,0,1.75-0.14,pi/2,0,0,{0,0}};
bool RealisticLighting=true;
bool RealisticMinification=true;
bool MotionBlur=true;
int MBSamples=4;
bool TwoEyesVision=false;
float NoseEyeDist=0.04;

int iii=0;

bool EnableZBuffer=true;
bool TripleBuffering=false;

float ScreenWidth=640;
float ScreenHeight=480;
GrScreenResolution_t grRes=GR_RESOLUTION_640x480;

WORD *FrontBuffer;
DWORD *FrontBuffer32;

bool AA=true;
int CircDetail=6;
float Gamma;	

#define Color DWORD

#define TypeConv(A) ((float)(short)(A))

float MonitorWeariness=0;
int GammaState=0;

float z0=0;

HDC ScreenDC;
HBITMAP VRam;
BYTE *VData;
BITMAPINFO VAttr;
HWND hWnd;

//char FileName[1024]="E:\\Alexandr\\ \\Metafile\\Metaedit\\WMF\\prntout2.wmf";
char FileName[1024]="C:\\Temp\\XP\\3Dfx\\WMF\\disk35.wmf";

BYTE BitmapHeader[54]={0x42,0x4D,0x36,0,0x24,0,0,0,0,0,0x36,0,0,0,0x28,0,0,0,0x20,3,0,0,0x58,2,0,0,1,0,0x18,0,0,0,0,0,0,0,0x24,0,0xC4,0xE,0,0,0xC4,0xE,0,0,0,0,0,0,0,0,0,0};
BYTE *BitmapData;

DWORD WINAPI Drawing(LPVOID);

int InStr(int start,const char *s,char symbol) {
	int i,l=strlen(s);
	for (i=start;i<l;i++)
		if (symbol==s[i]) return i;
	return -1;
}

int InStr(int start,const char *s,const char *s2) {
	int i,j,l,l2;
	bool b;
	l=strlen(s);
	l2=strlen(s2);
	if ((l<l2)||(l2<=0)) return -1;
	for (i=0;i<=l-l2;i++)
		if (s[i]==s2[0]) {
			b=true;
			for (j=1;j<l2;j++) b=b&&(s[i+j]==s2[j]);
			if (b) return i;
		}
	return -1;
}

int sign(float x) {
	return (x==0)?0:(x/fabs(x));
}

int Orientation (float x1,float y1,float x2,float y2,float x3,float y3) {
	return sign((x2-x1)*(y3-y2)-(y2-y1)*(x3-x2));
}

#define MIN(a,b) ((a<b)?a:b)
#define MAX(a,b) ((a>b)?a:b)
#define IN_INTERVAL(a,a1,a2) ((a>=MIN(a1,a2))&&(a<=MAX(a1,a2)))

bool Peresec(float x1,float y1,float x2,float y2,float x3,float y3,float x4,float y4,float *x,float *y) {
	if (((x1==x3)&&(y1==y3))||((x1==x4)&&(y1==y4))) {*x=x1; *y=y1; return true;}
	if (((x2==x3)&&(y2==y3))||((x2==x4)&&(y2==y4))) {*x=x2; *y=y2; return true;}
	float f1=(y1-y2)*(x3-x4)-(x1-x2)*(y3-y4);
	float f2=(y3-y1)*(x1-x2)*(x3-x4)+x1*(y1-y2)*(x3-x4)-x3*(x1-x2)*(y3-y4);
	if (!f1) {
		*x=*y=1e32;
		if (f2) return false; else return IN_INTERVAL(x1,x3,x4)||IN_INTERVAL(x2,x3,x4);
	} else {
		*x=f2/f1;
		if (x1==x2) *y=(y4-y3)*(*x-x3)/(x4-x3)+y3; else *y=(y2-y1)*(*x-x1)/(x2-x1)+y1;
		return IN_INTERVAL(*x,x1,x2)&&IN_INTERVAL(*x,x3,x4)&&IN_INTERVAL(*y,y1,y2)&&IN_INTERVAL(*y,y3,y4);
	}
}

int NearestExist (int i,bool *src,int count) {
	for (int j=0;j<count;j++) if (src[(i+j)%count]) return (i+j)%count;
	return -1;
}

int PrevExist (int i,bool *src,int count) {
	for (int j=0;j<count;j++) if (src[(i+count-j)%count]) return (i+count-j)%count;
	return -1;
}

bool InTriangle(float x1,float y1,float x2,float y2,float x3,float y3,float x,float y) {
	float const eps=0;
	float v=(x-x1)*(y2-y1)-(y-y1)*(x2-x1);
	if (((x-x2)*(y3-y2)-(y-y2)*(x3-x2))*v>=-eps)
		if (((x-x3)*(y1-y3)-(y-y3)*(x1-x3))*v>=-eps)
			return true;
	return false;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

	//SetEnvironmentVariable("FX_GLIDE_AA_TOGGLE_KEY","0");
	//SetEnvironmentVariable("SSTH3_SLI_AA_CONFIGURATION","4");
	//SetEnvironmentVariable("FX_GLIDE_AA_SAMPLE","4");
	//SetEnvironmentVariable("FX_GLIDE_SCREENSHOT_KEY","*");
	//SetEnvironmentVariable("FX_GLIDE_BPP","32");
	//_putenv("FX_GLIDE_BPP=32");

	if (strlen(lpCmdLine)) {
		strcpy(FileName,lpCmdLine+((lpCmdLine[0]==34)?1:0));
		if (FileName[strlen(FileName)-1]==34) FileName[strlen(FileName)-1]=0;
	}
	char CurDir[1024];
	strcpy(CurDir,GetCommandLine());
	CurDir[InStr(0,CurDir,"GlideWMF.exe")]=0;
	if (CurDir[0]==34)
		SetCurrentDirectory(CurDir+1);
	else
		SetCurrentDirectory(CurDir);

 WNDCLASS	wc;
 
 MSG		Msg;

 wc.style         = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc   = WindowProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
 wc.hCursor       = LoadCursor(NULL, IDC_ARROW); //  
 wc.hbrBackground = NULL;                        //  
 wc.lpszMenuName  = NULL;                        //    
 wc.lpszClassName = "Glide";
 RegisterClass(&wc);
 hWnd = CreateWindow("Glide",
                     "GlideWMF",
                     WS_POPUP,
                     0, 0,
                     GetSystemMetrics(SM_CXSCREEN),
                     GetSystemMetrics(SM_CYSCREEN),
                     NULL,
                     NULL,
                     hInstance,
                     NULL);
 if (hWnd == NULL)
  return 1;
 ShowWindow(hWnd, nCmdShow);
 /*while (GetMessage(&Msg, NULL, 0, 0))
 {TranslateMessage(&Msg);
  DispatchMessage(&Msg);
 }*/
 //Start(hWnd);
 return 0;
}
//-----------------------------------------------------------------------------
//
LRESULT CALLBACK WindowProc(HWND hWnd,
                            UINT uMsg,
                            WPARAM wParam,
                            LPARAM lParam)
{switch (uMsg)
 {case WM_ACTIVATE:
	if (LOWORD(wParam)==WA_ACTIVE) {
		if (!Start(hWnd))
			return -1;
	};
	return 0;
  case WM_DESTROY:
   ShutDown();
   PostQuitMessage(0);
   return 0;
  case WM_SETCURSOR:
   SetCursor(FALSE);
   return TRUE;
  case WM_KEYUP:
   if (wParam == VK_ESCAPE)
    DestroyWindow(hWnd);
   return 0;
 }
 return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
//---------------------------------------------------------------------------
// "" 3DFX
bool Start(HWND hWnd)
{
	LPTSTR env;
	env=GetEnvironmentStrings();
	//SetEnvironmentVariable("FX_GLIDE_BPP","32");
	//      3dfx
	if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx)) return false;
	char ScrMode[16];
	char Buffering[16];
	int BoardNumber=0;
	FILE *devcfg=fopen("GlideDevice.cfg","rt");
	if (devcfg) {
		fscanf(devcfg,"%i",&BoardNumber);
		fscanf(devcfg,"%s",ScrMode);
		fscanf(devcfg,"%s",Buffering);
		fclose(devcfg);	
		if (strlen(ScrMode)>=7) {
			if (!strcmp(ScrMode,"320x240")) {grRes=GR_RESOLUTION_320x240; ScreenWidth=320; ScreenHeight=240;}
			if (!strcmp(ScrMode,"400x300")) {grRes=GR_RESOLUTION_400x300; ScreenWidth=400; ScreenHeight=300;}
			if (!strcmp(ScrMode,"512x384")) {grRes=GR_RESOLUTION_512x384; ScreenWidth=512; ScreenHeight=384;}
			if (!strcmp(ScrMode,"640x480")) {grRes=GR_RESOLUTION_640x480; ScreenWidth=640; ScreenHeight=480;}
			if (!strcmp(ScrMode,"800x600")) {grRes=GR_RESOLUTION_800x600; ScreenWidth=800; ScreenHeight=600;}
			if (!strcmp(ScrMode,"960x720")) {grRes=GR_RESOLUTION_960x720; ScreenWidth=960; ScreenHeight=720;}
			if (!strcmp(ScrMode,"1024x768")) {grRes=GR_RESOLUTION_1024x768; ScreenWidth=1024; ScreenHeight=768;}
			if (!strcmp(ScrMode,"1600x1200")) {grRes=GR_RESOLUTION_1600x1200; ScreenWidth=1600; ScreenHeight=1200;}
			if (!strcmp(ScrMode,"320x200")) {grRes=GR_RESOLUTION_320x200; ScreenWidth=320; ScreenHeight=200;}
			if (!strcmp(ScrMode,"400x256")) {grRes=GR_RESOLUTION_400x256; ScreenWidth=400; ScreenHeight=256;}
			if (!strcmp(ScrMode,"512x256")) {grRes=GR_RESOLUTION_512x256; ScreenWidth=512; ScreenHeight=256;}
			if (!strcmp(ScrMode,"640x200")) {grRes=GR_RESOLUTION_640x200; ScreenWidth=640; ScreenHeight=200;}
			if (!strcmp(ScrMode,"640x350")) {grRes=GR_RESOLUTION_640x350; ScreenWidth=640; ScreenHeight=350;}
			if (!strcmp(ScrMode,"640x400")) {grRes=GR_RESOLUTION_640x400; ScreenWidth=640; ScreenHeight=400;}
			if (!strcmp(ScrMode,"856x480")) {grRes=GR_RESOLUTION_856x480; ScreenWidth=856; ScreenHeight=480;}
			if (!strcmp(ScrMode,"1280x1024")) {grRes=GR_RESOLUTION_1280x1024; ScreenWidth=1280; ScreenHeight=1024;}
			if (!strcmp(ScrMode,"1152x864")) {grRes=16; ScreenWidth=1152; ScreenHeight=864;}
		}
	}

	if ((BoardNumber<0)||(BoardNumber>Num3Dfx-1)) {
		MessageBox(hWnd,"Wrong device number (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
		return false;
	}
	TripleBuffering=(Buffering[0]=='T')||(Buffering[0]=='t');
	#ifdef GLIDE_DRAWING
		//ScreenDC=CreateDC("DISPLAY","","",0);
		//if (ScreenDC) Sleep(5000);
		//VRam=CreateCompatibleBitmap(ScreenDC,800,600);
		//VRam=CreateDIBSection(ScreenDC,&VAttr,DIB_RGB_COLORS,(VOID**)(VData),NULL,0);
		//VData=new BYTE [4*1024*1024];
		//if (VData) Sleep(5000);
		//VData=(unsigned char*)0xE8000000;
		//VData[0];
		//if (GetDIBits(ScreenDC,VRam,0,600,0,&VAttr,0)) {
		//	Sleep(5000);
		//}
		//if (VAttr.bmiHeader.biWidth==800) Sleep(5000); 
		/*COLORREF color;
		for (int y=0; y<240; y++)
			for (int x=0; x<320; x++) {
				color=GetPixel(ScreenDC,x,y);
				VData[(320*y+x)*4]=GetBValue(color);
				VData[(320*y+x)*4+1]=GetGValue(color);
				VData[(320*y+x)*4+2]=GetRValue(color);
				VData[(320*y+x)*4+3]=0;
			}*/
		grGlideInit();
		grSstSelect(BoardNumber);
		//grRes=16;
		//ScreenWidth=1152; ScreenHeight=864;
		Context = grSstWinOpen((FxU32)GetForegroundWindow(),             //  
								grRes,					// 
								GR_REFRESH_85Hz,        //  
								GR_COLORFORMAT_ABGR,    //  
								GR_ORIGIN_UPPER_LEFT,	//   (0,0)
								TripleBuffering?3:2,    //  
								EnableZBuffer?1:0);     //    Z-
		if (Context == NULL) {
			MessageBox(hWnd,"Can't set video mode (GlideDevice.cfg)","Glide WMF",MB_ICONERROR);
			return false;
		}

	#endif
	char str[256];
	GetEnvironmentVariable("FX_GLIDE_BPP",str,255);
	//MessageBox(hWnd,str,0,0);
	FreeEnvironmentStrings(env);
	if (!Drawing(0)) return false;
	return true;
}

// 
void ShutDown()
{
	#ifdef GLIDE_DRAWING
		grSstWinClose(Context);
		grGlideShutdown();
	#endif
}

float SetGamma(float gamma) {
	float gm=gamma;
	if (GammaState!=1) {
		if (gm<1./8) gm=1./8;
		if (gm>8) gm=8;
	}
	FxU32 *r,*g,*b;
	FxI32 nEntries;
	grGet(GR_GAMMA_TABLE_ENTRIES,4,&nEntries);
	r=new FxU32 [nEntries];
	g=new FxU32 [nEntries];
	b=new FxU32 [nEntries];
	float f,f0,f1;
	int i;
	f0=MonitorWeariness;
	f1=1/gm;
	for (i=0; i<nEntries; i++) {
		f=i/(nEntries-1.);
		r[i]=g[i]=b[i]=255*(f0+(1-f0)*pow(f,f1));
	}
	r[0]=g[0]=b[0]=0;
	#ifdef GLIDE_DRAWING
		grLoadGammaTable(nEntries,r,g,b);
	#endif
	if (GammaState==2) {
		DWORD dw=4*nEntries;
		BYTE *gtv;
		gtv=new BYTE [dw];
		HANDLE hGammaTable;
		hGammaTable=CreateFile("GammaTable.dat",GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
		if (hGammaTable!=INVALID_HANDLE_VALUE) {
			for (i=0;i<nEntries;i++) {
				gtv[4*i]=r[i];
				gtv[4*i+1]=g[i];
				gtv[4*i+2]=b[i];
				gtv[4*i+3]=0;
			}
			WriteFile(hGammaTable,gtv,dw,&dw,0);
		}
		CloseHandle(hGammaTable);
		/*FILE *gt=fopen("GammaTable.dat","wt");
		if (gt) {
			fprintf(gt);
			fclose(gt);
		}*/
		delete [] gtv;
		//To gammatable.dat
		GammaState=0;
	}
	delete [] r;
	delete [] g;
	delete [] b;
	//guGammaCorrectionRGB(gm,gm,gm);
	return gm;
}

float DefaultGamma() {
	float gm;
	FILE *fg=fopen("GlideColors.cfg","rt");
	if (fg) {
		fscanf(fg,"%f",&gm);
		fscanf(fg,"%f",&MonitorWeariness);
		fclose(fg);
	} else gm=1.2;
	if (MonitorWeariness<0) MonitorWeariness=0;
	if (MonitorWeariness>0.5) MonitorWeariness=0.5;
	return SetGamma(gm);
}

void DrawWall(int i,float shx,float shy,float px,float py,float pa) {
	float ca=cos(pa);
	float sa=sin(pa);
	float dx1,dy1,dx2,dy2;
	float s1,s2,s3,w1,w2,w3;
	float sw2=ScreenWidth/2;
	float sh2=ScreenHeight/2;
	float t=sw2/sh2+0.1;
	float xs1,xs2,nd1,nd2;
	float as1,as2,aw1,aw2;		// alternative s,w
	float ts1,ts2,tt=256;		// texture coordinates
	float ats1,ats2;			// alternative tex. coord.
	bool a1,a2,b1,b2,tv;
	myVertex vtx[6];
	myVertex vtxCeiling[4];
	myVertex vtxFloor[4];

	
	dx1=Walls[i].x1-px;
	dy1=Walls[i].y1-py;
	dx2=Walls[i].x2-px;
	dy2=Walls[i].y2-py;
	w1=dx1*ca+dy1*sa;
	w2=dx2*ca+dy2*sa;
	s1=(dx1*sa-dy1*ca);
	s2=(dx2*sa-dy2*ca);
	ts1=0; ts2=256*Walls[i].Length()/WallHeight;
	nd1=w1*(s2-s1)-s1*(w2-w1);
	nd2=(s2-s1)/t;
	as1=nd1/(w1-w2+nd2);
	as2=nd1/(w1-w2-nd2);
	a1=(as1>=0)&&(fabs(fabs(as1-s1)+fabs(as1-s2)-fabs(s1-s2))<e0);
	a2=(as2<0)&&(fabs(fabs(as2-s1)+fabs(as2-s2)-fabs(s1-s2))<e0);
	if (a1) {
		aw1=fabs(as1)/t;
		ats1=ts1+(ts2-ts1)*((as1+aw1)-(s1+w1))/((s2+w2)-(s1+w1));
	}
	if (a2) {
		aw2=fabs(as2)/t;
		ats2=ts1+(ts2-ts1)*((as2+aw2)-(s1+w1))/((s2+w2)-(s1+w1));
	}
	if (fabs(fabs(aw1-w1)+fabs(aw1-w2)-fabs(w1-w2))>e0) a1=false;
	if (fabs(fabs(aw2-w1)+fabs(aw2-w2)-fabs(w1-w2))>e0) a2=false;
	b1=(w1+e0>fabs(s1)/t);
	b2=(w2+e0>fabs(s2)/t);
	if (a1||a2||(b1&&b2)) {
		if (a1&&a2) {
			if (s1>=0) {
				s1=as1; w1=aw1; ts1=ats1;
				s2=as2; w2=aw2; ts2=ats2;
			} else {
				s2=as1; w2=aw1; ts2=ats1;
				s1=as2; w1=aw2; ts1=ats2;
			}
		} else {
			if (a1) {
				if (!b1) {
					s1=as1; w1=aw1; ts1=ats1;
				} else {
					s2=as1; w2=aw1; ts2=ats1;
				}
			}
			if (a2) {
				if (!b1) {
					s1=as2; w1=aw2; ts1=ats2;
				} else {
					s2=as2; w2=aw2; ts2=ats2;
				}							
			}
		}
		if (RealisticLighting) {
			float k,ds,dw;
			ds=s2-s1;
			dw=w2-w1;
			k=-(s1*ds+w1*dw)/(ds*ds+dw*dw);
			tv=(k>0)&&(k<1);
			s3=s1+k*ds;
			w3=w1+k*dw;
		} else
			tv=false;
		xs1=sw2+sh2*s1/w1;
		xs2=sw2+sh2*s2/w2;
		vtx[0].x=vtx[2].x=xs1+shx;
		vtx[1].x=vtx[3].x=xs2+shx;
		vtx[0].y=shy+sh2*(1-(WallHeight-Personage.z)/w1);
		vtx[1].y=shy+sh2*(1-(WallHeight-Personage.z)/w2);
		vtx[2].y=shy+sh2*(1-(0-Personage.z)/w1);
		vtx[3].y=shy+sh2*(1-(0-Personage.z)/w2);
		vtx[0].z=vtx[2].z=1/w1;//sqrt(dx1*dx1+dy1*dy1);
		vtx[1].z=vtx[3].z=1/w2;//sqrt(dx2*dx2+dy2*dy2);
		if (RealisticLighting) {
			vtx[0].f=1/(w1*w1+s1*s1+(WallHeight-Personage.z)*(WallHeight-Personage.z));
			vtx[1].f=1/(w2*w2+s2*s2+(WallHeight-Personage.z)*(WallHeight-Personage.z));
			vtx[2].f=1/(w1*w1+s1*s1+Personage.z*Personage.z);
			vtx[3].f=1/(w2*w2+s2*s2+Personage.z*Personage.z);
		}
		vtx[0].a=vtx[1].a=vtx[2].a=vtx[3].a=255;
		vtx[0].s=ts1*vtx[0].z;
		vtx[1].s=ts2*vtx[1].z;
		vtx[2].s=ts1*vtx[2].z;
		vtx[3].s=ts2*vtx[3].z;
		vtx[0].t=0;
		vtx[1].t=0;
		vtx[2].t=tt*vtx[2].z;
		vtx[3].t=tt*vtx[3].z;
		/*grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER,
							GR_COMBINE_FACTOR_ONE,
							GR_COMBINE_LOCAL_CONSTANT,
							GR_COMBINE_OTHER_TEXTURE,
							FXFALSE );*/
		grTexSource(GR_TMU0, TexAddr[2], GR_MIPMAPLEVELMASK_BOTH, &(Textures[2]));
	grTexCombine( GR_TMU0, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, FXFALSE, FXFALSE );
	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_CLAMP);
	grTexFilterMode(GR_TMU0,RealisticMinification?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED,TexBlur[2]?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED);	

		vtxCeiling[0]=vtxCeiling[3]=vtx[0];
		vtxCeiling[1]=vtxCeiling[2]=vtx[1];
		for (int i=0;i<4;i++)
			if (vtxCeiling[i].y<0) vtxCeiling[i].y=0;
		vtxCeiling[3].y=vtxCeiling[2].y=0;
		vtxCeiling[3].f=vtxCeiling[2].f=0;
		//grAADrawTriangle(&vtxCeiling[0],&vtxCeiling[1],&vtxCeiling[2],AA,0,0);
		//grAADrawTriangle(&vtxCeiling[0],&vtxCeiling[3],&vtxCeiling[2],0,0,0);

		grTexSource(GR_TMU0, TexAddr[1], GR_MIPMAPLEVELMASK_BOTH, &(Textures[1]));
	grTexCombine( GR_TMU0, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, FXFALSE, FXFALSE );
	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_CLAMP);
	grTexFilterMode(GR_TMU0,RealisticMinification?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED,TexBlur[1]?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED);	
		vtxCeiling[0]=vtxCeiling[3]=vtx[2];
		vtxCeiling[1]=vtxCeiling[2]=vtx[3];
		vtxCeiling[3].y=vtxCeiling[2].y=ScreenHeight-1;
		
		//grAADrawTriangle(&vtxCeiling[0],&vtxCeiling[1],&vtxCeiling[2],AA,0,0);
		//grAADrawTriangle(&vtxCeiling[0],&vtxCeiling[3],&vtxCeiling[2],0,0,0);

		grTexSource(GR_TMU0, TexAddr[0], GR_MIPMAPLEVELMASK_BOTH, &(Textures[0]));
	grTexCombine( GR_TMU0, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE, FXFALSE, FXFALSE );
	grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_CLAMP);
	grTexFilterMode(GR_TMU0,RealisticMinification?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED,TexBlur[0]?GR_TEXTUREFILTER_BILINEAR:GR_TEXTUREFILTER_POINT_SAMPLED);	


		grConstantColorValue(Walls[i].c);
		if (tv) {
			float xs3,ts3;
			xs3=sw2+sh2*s3/w3;
			vtx[4].x=xs3+shx;
			vtx[4].y=shy+sh2*(1-(Personage.z-Personage.z)/w3);
			vtx[4].z=1/w3;
			vtx[4].f=1/(w3*w3+s3*s3);
			vtx[4].a=255;
			ts3=ts1+(ts2-ts1)*((s3+w3)-(s1+w1))/((s2+w2)-(s1+w1));
			vtx[4].s=ts3*vtx[4].z;
			vtx[4].t=tt*vtx[4].z*(1-Personage.z/WallHeight);
			grAADrawTriangle(&vtx[0],&vtx[1],&vtx[4],AA,0,0);
			grAADrawTriangle(&vtx[1],&vtx[3],&vtx[4],AA,0,0);
			grAADrawTriangle(&vtx[3],&vtx[2],&vtx[4],AA,0,0);
			grAADrawTriangle(&vtx[2],&vtx[0],&vtx[4],AA,0,0);
		} else {
			grAADrawTriangle(&vtx[0],&vtx[1],&vtx[2],AA,0,AA);
			grAADrawTriangle(&vtx[1],&vtx[2],&vtx[3],0,AA,AA);
		}
		
		/*FILE *f=fopen("FindIgos.log","wt");
		for (j=0;j<4;j++)
			fprintf(f,"%f %f\n",vtx[j].x,vtx[j].y);
		fclose(f);*/
	}
}

DWORD WINAPI Drawing(LPVOID)
{

	//SetForegroundWindow(hWnd);

	//Sleep(1000);

	//DestroyWindow(hWnd);

	FxI32 FogTableEntries;

	DWORD BeginTime=GetTickCount();
	DWORD Frames=0;

	DWORD t=GetTickCount();
	DWORD dt=0,dw;

	int i,j,k;

	#define grBufferClearExt ((void (__stdcall *)(GrColor_t, GrAlpha_t, FxU32, FxU32)) grGetProcAddress("grBufferClearExt"))

	#define grTBufferWriteMaskExt ((void (__stdcall *)(FxU32)) grGetProcAddress("grTBufferWriteMaskExt"))

	#define grGetRegistryOrEnvironmentStringExt ((void (__stdcall *)(char*,char*)) grGetProcAddress("grGetRegistryOrEnvironmentStringExt"))

	if (true) {

		#ifdef GLIDE_DRAWING

			grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER,
							GR_COMBINE_FACTOR_ONE,
							GR_COMBINE_LOCAL_CONSTANT,
							GR_COMBINE_OTHER_TEXTURE,
							FXFALSE );

				//   -
			 grAlphaCombine(GR_COMBINE_FUNCTION_BLEND, //   -
							GR_COMBINE_FACTOR_ONE,           // 
							GR_COMBINE_LOCAL_ITERATED,       //
							GR_COMBINE_OTHER_ITERATED,       //
							FXFALSE);                        //   -

			 grAlphaBlendFunction(GR_BLEND_SRC_ALPHA,
								  GR_BLEND_ONE_MINUS_SRC_ALPHA,
								  GR_BLEND_ZERO,
								  GR_BLEND_ZERO);

			 //  Z-
			if (EnableZBuffer) {
				//grDepthBufferMode(GR_DEPTHBUFFER_ZBUFFER);      //  Z-
				//grDepthBufferFunction(GR_CMP_GREATER);
				//grDepthMask(FXTRUE);
			}
 
			grCoordinateSpace(GR_WINDOW_COORDS);
			//     
			grVertexLayout(GR_PARAM_XY, 0, GR_PARAM_ENABLE);	//   X, Y
			grVertexLayout(GR_PARAM_Q, 8, GR_PARAM_ENABLE);
			grVertexLayout(GR_PARAM_A, 12, GR_PARAM_ENABLE);	// -
			grVertexLayout(GR_PARAM_ST0, 16, GR_PARAM_ENABLE);
			if (RealisticLighting)
				grVertexLayout(GR_PARAM_FOG_EXT, 24, GR_PARAM_ENABLE);

			grFogColorValue(0);
			if (RealisticLighting)
				grFogMode(GR_FOG_WITH_TABLE_ON_FOGCOORD_EXT);
			else
				grFogMode(GR_FOG_WITH_TABLE_ON_Q);
			grGet(GR_FOG_TABLE_ENTRIES,4,&FogTableEntries);
			GrFog_t *ft=new GrFog_t [FogTableEntries];
			float BackgroundLighting=0;
			float Light=10;
			float FogEntry;
			float FogDistance;
			//guFogGenerateLinear(ft,0.1,10);
			for (int i=0;i<FogTableEntries;i++) {
				//ft[i]=255*sqrt(sqrt((i*i)/(FogTableEntries*FogTableEntries)));
				//FogEntry=1-(Light*(1-BackgroundLighting)/(FogDistance*FogDistance)+BackgroundLighting);
				if (RealisticLighting)
					FogEntry=1-(Light*(1-BackgroundLighting)/guFogTableIndexToW(i)+BackgroundLighting);
				else {
					FogDistance=guFogTableIndexToW(i);
					FogEntry=1-(Light*(1-BackgroundLighting)/(FogDistance*FogDistance)+BackgroundLighting);
				}
				if (FogEntry<0) FogEntry=0;
				if (FogEntry>1) FogEntry=1;
				ft[i]=255*FogEntry;
			}
			grFogTable(ft);

			 //  
			grBufferClear( 0, 0, 0 );

		#endif

		Gamma=DefaultGamma();

		POINT mcp,lmcp,cmcp;

		Gu3dfInfo fileInfo;
		FxU32 textureSize,startAddress;
		GrTexInfo info;

		
		
		/*if (!gu3dfGetInfo("matt1.3df", &fileInfo)) goto crash;
		fileInfo.data = new char [fileInfo.mem_required];
		if (!gu3dfLoad("matt1.3df", &fileInfo)) goto crash;

		//FxU16 mipmap[256*256 + 128*128 + 64*64 + 32*32 + 256 + 64 + 16 + 4 + 1];
		info.smallLodLog2 = fileInfo.header.small_lod;
		info.largeLodLog2 = fileInfo.header.large_lod;
		info.aspectRatioLog2 = fileInfo.header.aspect_ratio;
		info.format = fileInfo.header.format;
		info.data = fileInfo.data;*/

		startAddress=grTexMinAddress(GR_TMU0);

		for (i=0;i<3;i++) {
			const int TexSize=8;
			HANDLE hBmpTex;
			BYTE BmpHeader[54];
			BYTE *BmpData=new BYTE [3*(1<<(2*TexSize))];
			hBmpTex=CreateFile(PictureFileName[i],GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
			if (hBmpTex==INVALID_HANDLE_VALUE) goto crash;
			dw=54; ReadFile(hBmpTex,BmpHeader,dw,&dw,NULL);
			dw=3*(1<<(2*TexSize)); ReadFile(hBmpTex,BmpData,dw,&dw,NULL);
			CloseHandle(hBmpTex);
			unsigned short TexData[1<<(2*TexSize)];
			for (j=0;j<1<<(2*TexSize);j++)
				TexData[j]=(BmpData[3*j]>>3)+((BmpData[3*j+1]>>2)<<5)+((BmpData[3*j+2]>>3)<<11);
			Textures[i].smallLodLog2=TexSize;
			Textures[i].largeLodLog2=TexSize;
			Textures[i].aspectRatioLog2=0;
			Textures[i].format=GR_TEXFMT_RGB_565;
			Textures[i].data=TexData;
			textureSize = grTexTextureMemRequired(GR_MIPMAPLEVELMASK_BOTH, &(Textures[i]));
			if ((startAddress + textureSize)> grTexMaxAddress(GR_TMU0)) {
				printf("error: texture too big for TMU0\n");
				goto crash;
			}
			grTexDownloadMipMap(GR_TMU0, startAddress, GR_MIPMAPLEVELMASK_BOTH, &(Textures[i]));
			TexAddr[i]=startAddress;
			startAddress+=textureSize;
		}
		

		grTexMipMapMode(GR_TMU0,GR_MIPMAP_NEAREST_DITHER,FXFALSE);
		//grTexLodBiasValue(GR_TMU0,2);

		cmcp.x=lmcp.x=ScreenWidth/2;
		cmcp.y=lmcp.y=0;
		SetCursorPos(cmcp.x,cmcp.y);

		float ShiftX[4];
		float ShiftY[4];

		int CadrNumber=0;

		float spd;

		do {

			#ifdef GLIDE_DRAWING
				if (CadrNumber%MBSamples==0) {
					grTBufferWriteMaskExt(0x0f);
					//grBufferClearExt( 0x000000, 0, 0, 0 );
					grBufferClear( 0x000000, 0, 0 );
				}
			#endif

			spd=MotionBlur?(1.0/MBSamples):1.0;

			t+=(dt=GetTickCount()-t*1.);

			float step=1;
			float f;

			if (dt<8) step=dt/8.;
			if (dt>40) step=dt/40.;

			/*if (Frames%10==0) {
				SetActiveWindow(hWnd);
				SetForegroundWindow(hWnd);
				Sleep(100);
			}*/

			if (Frames%1==0) {
				if (1&GetAsyncKeyState(80)) {
					FxI32 bpc[4];
					if (grGet(GR_BITS_RGBA,16,bpc)==16) {
						BitmapHeader[18]=((WORD)ScreenWidth)%256;
						BitmapHeader[19]=((WORD)ScreenWidth)/256;
						BitmapHeader[22]=((WORD)ScreenHeight)%256;
						BitmapHeader[23]=((WORD)ScreenHeight)/256;
						BitmapData=new BYTE [3*ScreenWidth*ScreenHeight];
						if (bpc[0]+bpc[1]+bpc[2]==16) {
							FrontBuffer=new WORD [ScreenWidth*ScreenHeight];
							grLfbReadRegion(GR_BUFFER_FRONTBUFFER,0,0,ScreenWidth,ScreenHeight,2*ScreenWidth,FrontBuffer);
							k=0; WORD FBValue;
							for (j=0;j<ScreenHeight;j++)
								for (i=0;i<ScreenWidth;i++) {
									FBValue=FrontBuffer[((int)ScreenHeight-1-j)*(int)ScreenWidth+i];
									BitmapData[3*k]=(FBValue&0x001F)<<3;
									BitmapData[3*k+1]=(FBValue&0x07E0)>>3;
									BitmapData[3*k+2]=(FBValue&0xF800)>>8;
									k++;
								}
						} else {
							FrontBuffer32=new DWORD [ScreenWidth*ScreenHeight];
							grLfbReadRegion(GR_BUFFER_FRONTBUFFER,0,0,ScreenWidth,ScreenHeight,4*ScreenWidth,FrontBuffer32);
							k=0; DWORD FBValue;
							for (j=0;j<ScreenHeight;j++)
								for (i=0;i<ScreenWidth;i++) {
									FBValue=FrontBuffer32[((int)ScreenHeight-1-j)*(int)ScreenWidth+i];
									BitmapData[3*k]=(FBValue&0xFF);
									BitmapData[3*k+1]=(FBValue&0xFF00)>>8;
									BitmapData[3*k+2]=(FBValue&0xFF0000)>>16;
									k++;
								}
						}
						HANDLE hBmpFile;
						hBmpFile=CreateFile("Photo.bmp",GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
						if (hBmpFile!=INVALID_HANDLE_VALUE) {
							dw=54;
							WriteFile(hBmpFile,BitmapHeader,dw,&dw,0);
							dw=3*ScreenWidth*ScreenHeight;
							WriteFile(hBmpFile,BitmapData,dw,&dw,0);
						}
						CloseHandle(hBmpFile);
						delete [] BitmapData;
						delete [] FrontBuffer;
					}
				}
				if (1&GetAsyncKeyState(65)) AA=!AA;
				f=pow(1.01,step);
				if (GetAsyncKeyState(71)) {
					if (!GammaState) {
						GammaState=1;
						SetGamma(1e-10);
					}
				} else {
					if (GammaState==1) {
						GammaState=2;
						SetGamma(Gamma);
					}
					if (1&GetAsyncKeyState(36)) Gamma=DefaultGamma();
					if (1&GetAsyncKeyState(35)) {
						FILE *fg=fopen("GlideColors.cfg","wt");
						if (fg) {
							fprintf(fg,"%f\n",Gamma);
							fprintf(fg,"%f",MonitorWeariness);
							fclose(fg);
						}
					}
					f=1;
					if (GetAsyncKeyState(33)) f*=pow(1.01,step);
					if (GetAsyncKeyState(34)) f/=pow(1.01,step);
					if (f!=1) Gamma=SetGamma(Gamma*f);
				}
				//SetCursorPos(ScreenWidth/2,ScreenHeight/2);

				float oldv,newv;
				oldv=sqrt(Personage.vx*Personage.vx+Personage.vy*Personage.vy);
				if (oldv) {
					newv=oldv-0.001;
					if (newv<0) newv=0;
					Personage.vx*=(newv/oldv);
					Personage.vy*=(newv/oldv);
				}
				if (GetAsyncKeyState(VK_UP)) {
					Personage.vx+=0.005*spd*cos(Personage.a);
					Personage.vy+=0.005*spd*sin(Personage.a);
				}
				if (GetAsyncKeyState(VK_DOWN)) {
					Personage.vx-=0.005*spd*cos(Personage.a);
					Personage.vy-=0.005*spd*sin(Personage.a);
				}
				if (fabs(Personage.x)>9.5) Personage.vx=-sign(Personage.x)*fabs(Personage.vx)/2;
				if (fabs(Personage.y)>9.5) Personage.vy=-sign(Personage.y)*fabs(Personage.vy)/2;
				Personage.x+=Personage.vx;
				Personage.y+=Personage.vy;
				if (GetAsyncKeyState(17)) {
					if (GetAsyncKeyState(VK_LEFT)) {
						Personage.x+=0.1*spd*cos(Personage.a+pi/2);
						Personage.y+=0.1*spd*sin(Personage.a+pi/2);
					}
					if (GetAsyncKeyState(VK_RIGHT)) {
						Personage.x+=0.1*spd*cos(Personage.a-pi/2);
						Personage.y+=0.1*spd*sin(Personage.a-pi/2);
					}
				} else {
					if (GetAsyncKeyState(VK_LEFT)) Personage.a+=0.04*spd;
					if (GetAsyncKeyState(VK_RIGHT)) Personage.a-=0.04*spd;
				}
			}

			if (MotionBlur) {
				/*if (CadrNumber%2==0)
					grTBufferWriteMaskExt(1+4);
				else
					grTBufferWriteMaskExt(2+8);*/
				grTBufferWriteMaskExt(1<<(CadrNumber%MBSamples));	
			}

			bool che=true;

			if ((CadrNumber%MBSamples)&&MotionBlur) {
				float prt=(float)(CadrNumber%MBSamples)/MBSamples;
				mcp.x=cmcp.x+prt*(cmcp.x-lmcp.x);
				mcp.y=cmcp.y+prt*(cmcp.y-lmcp.y);
			} else {
				lmcp.x=cmcp.x;
				lmcp.y=cmcp.y;
				GetCursorPos(&cmcp);
				mcp.x=cmcp.x;
				mcp.y=cmcp.y;
			}

			float MaxEyeAngle=1;

			if (GetAsyncKeyState(1)) {
				Personage.a+=0.1*Personage.e.angle;
				che=false;
				Personage.e.angle*=0.9;
				mcp.x=cmcp.x=(1-Personage.e.angle/MaxEyeAngle)*ScreenWidth/2;
				SetCursorPos(cmcp.x,cmcp.y);
			}
			if (GetAsyncKeyState(2)) {
				che=false;
				Personage.e.angle*=0.9;
				mcp.x=cmcp.x=(1-Personage.e.angle/MaxEyeAngle)*ScreenWidth/2;
				SetCursorPos(cmcp.x,cmcp.y);
			}

			if (che) {
				Personage.e.angle=(1-2*mcp.x/ScreenWidth)*MaxEyeAngle;
				Personage.e.focan=(mcp.y/ScreenWidth)*pi/8;
			}

			float sh=0.3,rg=27*pi/180;
			float shx=0,shy=0;
			if (MotionBlur) {
				rg+=2*pi*(CadrNumber%MBSamples)/MBSamples;
				shx=sh*cos(rg);
				shy=sh*sin(rg);	
			}
			
			for (i=0;i<WallCount;i++) {
				if (TwoEyesVision&&MotionBlur) {
					float dx=NoseEyeDist*sin(Personage.a);
					float dy=NoseEyeDist*cos(Personage.a);
					if (CadrNumber%2)
						DrawWall(i,shx,shy,Personage.x+dx,Personage.y-dy,Personage.a+Personage.e.angle+Personage.e.focan); // right eye
					else
						DrawWall(i,shx,shy,Personage.x-dx,Personage.y+dy,Personage.a+Personage.e.angle-Personage.e.focan); // left eye
				} else
					DrawWall(i,shx,shy,Personage.x,Personage.y,Personage.a+Personage.e.angle);
			}

			if (MotionBlur) CadrNumber++;

			#ifdef GLIDE_DRAWING
				if (CadrNumber%MBSamples==0) {
					if (1&GetAsyncKeyState('M')) {
						MotionBlur=!MotionBlur;
						cmcp.x=lmcp.x=mcp.x;
						cmcp.y=lmcp.y=mcp.y;
					}
					if (1&GetAsyncKeyState('D'))
						TwoEyesVision=!TwoEyesVision;
					grFlush();
					//grTBufferWriteMaskExt(0x0f);
					grBufferSwap(1);
				}
			#endif
			Frames++;
		} while (!GetAsyncKeyState(27)&&!GetAsyncKeyState(91)&&!GetAsyncKeyState(92));

	}

crash:
	grTBufferWriteMaskExt(0x0f);
	ShutDown();

	DWORD EndTime=GetTickCount();

	FILE *fps=fopen("FindIgos.FPS","wt");
	#ifdef GLIDE_DRAWING
		fprintf(fps,"%s\n",grGetString(GR_HARDWARE));
	#endif
	fprintf(fps,"Fog table: %i entries\n",FogTableEntries);
	fprintf(fps,"%i FPS\n",1000*Frames/(EndTime-BeginTime));
	//char ev[256];
	//grGetRegistryOrEnvironmentStringExt("FX_GLIDE_AA4_OFFSET_X0",ev);
	//fprintf(fps,"%s\n",ev);
	char str[256];
	GetEnvironmentVariable("FX_GLIDE_BPP",str,255);
	//fprintf(fps,"%s",getenv("FX_GLIDE_BPP"));
	fclose(fps);

	DestroyWindow(hWnd);
	PostQuitMessage(0);
	return true;
}