/*

 here is the initialisation and the main loop of the demo
 at final , the triangle is like in OpenGL format when you
 want to print it .. you use three structure of three vertex.
 The function here GL2GLIDE does it but with Glide version

*/

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <glide.h>
#include	"Global.h"
#include "math3D.h"


GrHwConfiguration hwconfig;

void LoadTex(char *filename,GrMipMapId_t *decal0)
{
Gu3dfInfo         info;

	if ( !gu3dfGetInfo( filename , &info ) )  
	{
		fprintf(stderr, "ERROR: could not load texture \n");
		grGlideShutdown();
		exit( -1 );
	}
	else
	{
		info.data = malloc( info.mem_required );

		if ( info.data == 0 ) {
			fprintf( stderr, "out of memory for texture\n" );
			grGlideShutdown();
			exit( -1 );
		}

		if ( !gu3dfLoad( filename , &info ) ) {
			fprintf( stderr, "could not load texture file\n" );
			grGlideShutdown();
			exit( -1 );
		}

		*decal0 = guTexAllocateMemory( 0, GR_MIPMAPLEVELMASK_BOTH,
											  info.header.width, info.header.height,
											  info.header.format,
											  GR_MIPMAP_NEAREST,
											  info.header.small_lod, info.header.large_lod,
											  info.header.aspect_ratio,
											  GR_TEXTURECLAMP_WRAP, GR_TEXTURECLAMP_WRAP,
											  GR_TEXTUREFILTER_BILINEAR, GR_TEXTUREFILTER_BILINEAR,
											  0.0F,
											  FXFALSE );
		if ( *decal0 == GR_NULL_MIPMAP_HANDLE ) {
			fprintf( stderr, "could not allocate memory for Texture\n" );
			grGlideShutdown();
			exit( -1 );
		}
		guTexDownloadMipMap( *decal0, info.data, &info.table.nccTable );
		free( info.data );
	}
}






void main( int argc, char **argv )
{
	char *filetex ;
	float color = 255.f;
	int i=0,j,num_sst,jj;

	float	IsajouX = 0.0f;
	float	IsajouY = 0.0f;
	float	IsajouZ = 0.0f;
	float	IsaX,IsaY,IsaZ;
	float AngleZ= 0.1f;
	float	AngZ;

	FILE	*fp;      
	int NbPointLoad,NbFace;

	Vecteur	*VtObj;
	Vecteur  *VtObjD0;
	Vecteur  *VtObjD1;
	Face		*face;
	Transl	Trans[NbObj];

	GrMipMapId_t      decal0;
	GrMipMapId_t      decal1;
	GrScreenResolution_t screenRes;



	  
//---------------------------------------------------------------
// Charge l'objet 3D dans VtObj
//---------------------------------------------------------------

	if ((fp=fopen("obj.dat","r"))==NULL) {
		fputs ("Obj.dat : fichier Non trouve.\n",stderr);
		exit (-1);
	}

	fscanf (fp,"%d",&NbPointLoad);
	fscanf (fp,"%d",&NbFace);

	VtObj  = malloc(sizeof(Vecteur)*NbPointLoad);
	VtObjD0= malloc(sizeof(Vecteur)*NbPointLoad);
	VtObjD1= malloc(sizeof(Vecteur)*NbPointLoad);
	face 	 = malloc(sizeof(Face)*NbFace);

	for (i=0;i<NbPointLoad;i++) {
		fscanf (fp,"%e %e %e",&VtObj[i].x,&VtObj[i].y,&VtObj[i].z);
		fscanf (fp,"%e %e",&VtObj[i].s,&VtObj[i].t);
		VtObj[i].r=color;
		VtObj[i].g=color;
		VtObj[i].b=color;
	}

	for (i=0;i<NbFace;i++) {
		fscanf (fp,"%d %d %d",&face[i].pt1,&face[i].pt2,&face[i].pt3);
	}


//---------------------------------------------------------------
// Init 3DFX 
//---------------------------------------------------------------

	screenRes = GR_RESOLUTION_640x480;
	grGlideInit();

	if (!grSstQueryHardware(&hwconfig))
	{
		fprintf( stderr, "main: grSstQueryHardware failed!\n" );
		grGlideShutdown();
		exit( -1 );
	}

	num_sst = hwconfig.num_sst;

	for(jj=0; jj<num_sst; jj++) {
		grSstSelect( jj );

		if ( !grSstOpen( screenRes,
							  GR_REFRESH_60Hz,
							  GR_COLORFORMAT_ABGR,
							  GR_ORIGIN_LOWER_LEFT,
							  GR_SMOOTHING_ENABLE,
							  2 ) )
		{
		  fprintf( stderr, "main: grSstOpen failed for SST#%d!\n", jj );
		  grGlideShutdown();
		  exit( -1 );
		}
	}
  
//---------------------------------------------------------------
// Charge texture 3DF et initialisation d'ecriture 3DFX
//---------------------------------------------------------------



LoadTex ("miro.3DF",&decal0);
LoadTex ("matt1.3DF",&decal1);

guColorCombineFunction(GR_COLORCOMBINE_TEXTURE_TIMES_ITRGB);
//guColorCombineFunction(GR_COLORCOMBINE_DECAL_TEXTURE);
grTexCombineFunction(GR_TMU0, GR_TEXTURECOMBINE_DECAL);
//guColorCombineFunction( GR_COLORCOMBINE_ITRGB );
grDepthBufferMode(GR_DEPTHBUFFER_ZBUFFER);
grDepthBufferFunction(GR_CMP_GREATER);
grDepthMask(FXTRUE);

//---------------------------------------------------------------
// Main Loop
//---------------------------------------------------------------

	while ( 1 ) {

	grBufferClear( 0x000000, 0, GR_ZDEPTHVALUE_FARTHEST );

// Prepare les tableaux de translation a base d'icajou !

	IsaX=IsajouX;
	IsaY=IsajouY;
	IsaZ=IsajouZ;

	IsajouX+=0.01f;
	IsajouY+=0.02f;
	IsajouZ+=0.02f;

	for (i=0;i<NbObj;i++) {
		Trans[i].x=2.5f*sin(IsaX);
		Trans[i].y=2.5f*cos(IsaY);
		Trans[i].z=4.5f*sin(IsaZ)+6.0f;

	IsaX+=0.3f;
	IsaY+=0.3f;
	IsaZ+=0.5f;
	}



// Affiche les objets avec les translations
// Print Objects

AngZ=AngleZ;

	for (j=0;j<NbObj;j+=2) {

		RotateX	(VtObj, VtObjD0, AngZ,NbPointLoad);
		RotateY	(VtObjD0,VtObjD1,AngZ,NbPointLoad);
		guTexSource( decal0 );
		for (i=0;i<NbFace;i++) {
			GL2Glide (VtObj,VtObjD1,face,i,&Trans[j]);
		}

		AngZ+=0.05f;
		RotateX	(VtObj, VtObjD0, AngZ,NbPointLoad);
		RotateY	(VtObjD0,VtObjD1,AngZ,NbPointLoad);
		AngZ+=0.05f;
		guTexSource( decal1 );
		for (i=0;i<NbFace;i++) {
			GL2Glide (VtObj,VtObjD1,face,i,&Trans[j+1]);
		}
	}

	grBufferSwap( 1 );
	AngleZ+=0.03f;

		if (kbhit()) {
			getch();
			break;
		}
  }
  for(jj=0; jj<num_sst; jj++) {
	 grSstSelect( jj );
	 grGlideShutdown();
  }

}
